      subroutine bookplot(n,tag,titlex,var,wt,xmin,xmax,dx,llplot) 
      implicit none
      include 'nplot.f'
      integer n
      character*(*) titlex
      character*3 llplot
      character*4 tag,mypart
      double precision var,wt,xmin,xmax,dx
      common/mypart/mypart

      if (tag.eq.'book') then
          call mbook(n,titlex,dx,xmin,xmax)
          call mbook(200+n,titlex,dx,xmin,xmax)
          call mbook(400+n,titlex,dx,xmin,xmax)
          call mbook(600+n,titlex,dx,xmin,xmax)
          call mbook(800+n,titlex,dx,xmin,xmax)
          call mbook(1000+n,titlex,dx,xmin,xmax)
          call mbook(1200+n,titlex,dx,xmin,xmax)
      elseif (tag .eq. 'plot') then
          call mfill(n,var,wt)
        linlog(n)=llplot
        titlearray(n)=titlex
      endif

      return
      end

    
      subroutine plotter(p,wt,switch)
      implicit none
      include 'clustering.f'
      include 'constants.f'
      include 'cutoff.f'
      include 'jetlabel.f'
      include 'npart.f'
      include 'mxdim.f'
      include 'process.f'
      include 'removebr.f'
      include 'masses.f'


      character*2 plabel(mxpart)
      common/plabel/plabel

      integer n,switch,nplotmax,i,j
      character tag*4
  
      double precision wt
      double precision m34,p(mxpart,4),fphi,HT
      double precision pt3,pt4,pt5,pt6,pt7,pt8
      double precision eta3,eta4,eta5,eta6,eta7,eta8
      double precision pt34,y34,pjm,pt3dpt4,tmass,ptmin,ptmax,pt34om34
      double precision pt34aa,pt34a,pt34b,pt34c,pt34d,pt34e,pt34f,pt34g
      double precision pt340,pt341,pt342,pt343,pt344
      double precision pt4a,pt4b,pt4c,pt4d
      double precision eta4a,eta4b,eta4c,eta4d,eta4e,eta4f
      double precision pt,etarap,yraptwo,yrapfour,pttwo,R
      double precision cosphi34,deltaphi,pto(1:4),tmp(1:2),costh_CS
      integer eventpart,nqcdjets,nqcdstart
      double precision phi3,phi4,cosdelphi,delphi,phi_acop,theta_star
     &,phi_st


      logical first,jetmerge
      character*30 runstring
      common/runstring/runstring
      common/nplotmax/nplotmax
      common/nqcdjets/nqcdjets,nqcdstart
      common/jetmerge/jetmerge
      double precision realeventp(mxpart,4)
      common/realeventp/realeventp
      integer order,nproc,ndec
      common/nproc/nproc
      common/nnlo/order
      data first/.true./
      save first
       if (first) then
        tag='book'
c--- ensure we initialize all possible histograms
        eventpart=npart+3
        eta3=0d0
        pt3=0d0
        eta4=0d0
        pt4=0d0
        eta5=0d0
        pt5=0d0
        eta6=0d0
        pt6=0d0
        eta7=0d0
        pt7=0d0
        eta8=0d0
        pt8=0d0

        y34=0d0
        pt34=0d0
        pt34om34=0d0
        m34=0d0
        cosphi34=0d0
        costh_CS=0d0


        HT=0d0

        deltaphi=0d0
        phi3=0d0
        phi4=0d0
        cosdelphi=0d0
        delphi=0d0
        phi_acop=0d0
        theta_star=0d0
        phi_st=0d0

        pto(1)=0d0
        pto(2)=0d0
        pto(3)=0d0
        pto(4)=0d0


        jetmerge=.true.
CC      Here set jets to the maximum number of jets 
CC      to book the necessary histograms: 0 at LO, 1 at NLO and 2 at NNLO
        jets=order
CC
        goto 99
      else
        tag='plot'
      endif

C     ndec is the number of decay products of the vector boson

      ndec=2

C     enventpart is the total number of four momenta in the event
C     2 for initial state + ndec=2 for the V decay + number of jets 

      eventpart=2+ndec+jets
    

      eta3=etarap(3,p)
      pt3=pt(3,p)
      eta4=etarap(4,p)
      pt4=pt(4,p)        
      y34=yraptwo(3,4,p)
      pt34=pttwo(3,4,p)
      m34=dsqrt((p(3,4)+p(4,4))**2-(p(3,1)+p(4,1))**2
     .          -(p(3,2)+p(4,2))**2-(p(3,3)+p(4,3))**2)

      pt34om34=pt34/m34

      HT=pt3+pt4

C     Transverse mass

      pt3dpt4=p(3,1)*p(4,1)+p(3,2)*p(4,2)

      if(pt3*pt4.ge.pt3dpt4) then
      tmass=dsqrt(2d0*(pt3*pt4-pt3dpt4))
      else
      tmass=-999d0  ! do not bin
!      write(*,*) "WARNING! tmass^2=",2d0*(pt3*pt4-pt3dpt4)
      endif


       cosdelphi=dcosh(dabs(eta3-eta4))-m34**2/2d0/pt3/pt4
       if(cosdelphi.le.-1d0) then
          delphi=dacos(-1d0) 
       elseif(cosdelphi.gt.-1d0) then
          delphi=dacos(cosdelphi)
       endif

!       write(*,*) cosdelphi,delphi

       phi_acop=dacos(-1d0)-delphi
       theta_star=dacos(dtanh((eta3-eta4)/2d0))
       phi_st=dtan(phi_acop/2d0)*dsin(theta_star)


      ptmin=min(pt3,pt4)
      ptmax=max(pt3,pt4)


!  WRITE EVENTS ON FILE
!      call evtwriter(p,wt,switch)


 99   continue

      n=1                  
      
      call bookplot(n,tag,'qT',pt34,wt,0d0,500d0,5d0,'lin')
      n=n+1
      call bookplot(n,tag,'m34',m34,wt,40d0,350d0,10d0,'lin')
      n=n+1
      call bookplot(n,tag,'eta3',eta3,wt,-5d0,5d0,0.5d0,'lin')
      n=n+1
      call bookplot(n,tag,'eta4',eta4,wt,-5d0,5d0,0.5d0,'lin')
      n=n+1
      call bookplot(n,tag,'y34',y34,wt,-5d0,5d0,0.5d0,'lin')
      n=n+1
      call bookplot(n,tag,'pt3',pt3,wt,0d0,150d0,5d0,'lin')
      n=n+1      
      call bookplot(n,tag,'pt4',pt4,wt,0d0,150d0,5d0,'lin')
      n=n+1
      call bookplot(n,tag,'*1',phi_st,wt,0d0,0.028d0,0.004d0,'lin')
      n=n+1
      call bookplot(n,tag,'*2',phi_st,wt,0.019d0,0.044d0,0.005d0,'lin')
      n=n+1
      call bookplot(n,tag,'*3',phi_st,wt,0.033d0,0.063d0,0.006d0,'lin')
      n=n+1
      call bookplot(n,tag,'*4',phi_st,wt,0.050d0,0.071d0,0.007d0,'lin')
      n=n+1
      call bookplot(n,tag,'*5',phi_st,wt,0.056d0,0.080d0,0.008d0,'lin')
      n=n+1
!      call bookplot(n,tag,'*6',phi_st,wt,0.063d0,0.090d0,0.009d0,'lin')
!      n=n+1
!      call bookplot(n,tag,'*7',phi_st,wt,0.071d0,0.101d0,0.010d0,'lin')
!      n=n+1
!      call bookplot(n,tag,'*8',phi_st,wt,0.080d0,0.113d0,0.011d0,'lin')
!      n=n+1
!      call bookplot(n,tag,'*9',phi_st,wt,0.090d0,0.126d0,0.012d0,'lin')
!      n=n+1
!      call bookplot(n,tag,'*10',phi_st,wt,0.100d0,0.142d0,0.014d0,'lin')
!      n=n+1
!      call bookplot(n,tag,'*11',phi_st,wt,0.111d0,0.162d0,0.017d0,'lin')
!      n=n+1
!      call bookplot(n,tag,'*12',phi_st,wt,0.125d0,0.185d0,0.020d0,'lin')
!      n=n+1
!      call bookplot(n,tag,'*13',phi_st,wt,0.141d0,0.213d0,0.024d0,'lin')
!      n=n+1
!      call bookplot(n,tag,'*14',phi_st,wt,0.159d0,0.249d0,0.030d0,'lin')
!      n=n+1
!      call bookplot(n,tag,'*15',phi_st,wt,0.180d0,0.297d0,0.039d0,'lin')
!      n=n+1
!      call bookplot(n,tag,'*16',phi_st,wt,0.204d0,0.366d0,0.054d0,'lin')
!      n=n+1
!      call bookplot(n,tag,'*17',phi_st,wt,0.233d0,0.470d0,0.079d0,'lin')
!      n=n+1
!      call bookplot(n,tag,'*18',phi_st,wt,0.391d0,0.524d0,0.133d0,'lin')
!      n=n+1
!      call bookplot(n,tag,'*19',phi_st,wt,0.182d0,1.037d0,0.171d0,'lin')
!      n=n+1 
!      call bookplot(n,tag,'*20',phi_st,wt,0.695d0,0.918d0,0.223d0,'lin')
!      n=n+1
!      call bookplot(n,tag,'*21',phi_st,wt,0.918d0,1.153d0,0.235d0,'lin')
!      n=n+1
!      call bookplot(n,tag,'*22',phi_st,wt,0.810d0,1.839d0,0.343d0,'lin')
!      n=n+1
!      call bookplot(n,tag,'*23',phi_st,wt,1.496d0,1.947d0,0.451d0,'lin')
!      n=n+1
!      call bookplot(n,tag,'*24',phi_st,wt,1.372d0,3.672d0,0.575d0,'lin')
!      n=n+1
!      call bookplot(n,tag,'*25',phi_st,wt,2.522d0,3.277d0,0.755d0,'lin')
!      n=n+1
!      call bookplot(n,tag,'pt34',pt34,wt,0d0,20d0,2d0,'lin')
!      n=n+1
!      call bookplot(n,tag,'pt34a',pt34,wt,14d0,58d0,4d0,'lin')
!      n=n+1
!      call bookplot(n,tag,'pt34b',pt34,wt,48d0,66d0,6d0,'lin')
!      n=n+1
!      call bookplot(n,tag,'pt34c',pt34,wt,50d0,90d0,10d0,'lin')
!      n=n+1
!      call bookplot(n,tag,'pt34d',pt34,wt,60d0,120d0,20d0,'lin')
!      n=n+1
!      call bookplot(n,tag,'pt34e',pt34,wt,50d0,250d0,50d0,'lin')
!      n=n+1
!      call bookplot(n,tag,'pt34f',pt34,wt,100d0,400d0,100d0,'lin')
!      n=n+1
!      call bookplot(n,tag,'pt34g',pt34,wt,300d0,800d0,500d0,'lin')
!      n=n+1
!!!!!!!!!!!!!!!!!!!!!!!
!
    
      n=n-1

      if (n .gt. 200) then
        write(6,*) 'WARNING - TOO MANY HISTOGRAMS!'
        write(6,*) n,' > 200, which is the built-in maximum'
        stop
      endif

c--- set the maximum number of plots, on the first call
      if (first) then
        first=.false.
        nplotmax=n
      endif
      

      return 
      end
      

      
