      SUBROUTINE GRIDMAKER      

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER (NPART=8, NX=52, NARG=1)
      DIMENSION xb(nx)
      COMMON / INTINIP / IINIP

        DATA XB / 1.0E-6,5.E-6,
     1           1.0E-5, 1.4E-5, 2.0E-5, 3.0E-5, 4.5E-5, 6.7E-5,
     2           1.0E-4, 1.4E-4, 2.0E-4, 3.0E-4, 4.5E-4, 6.7E-4,
     3           1.0E-3, 1.4E-3, 2.0E-3, 3.0E-3, 4.5E-3, 6.7E-3,
     4           1.0E-2, 1.4E-2, 2.0E-2, 3.0E-2, 4.5E-2, 0.06, 0.08,
     5           0.1, 0.125, 0.15, 0.175, 0.2, 0.225, 0.25, 0.275,
     6           0.3, 0.325, 0.35, 0.375, 0.4,  0.45, 0.5, 0.55,
     7           0.6, 0.65,  0.7,  0.75,  0.8,  0.85, 0.9, 0.95, 1. /
      common/ CUV/ A1UV,A2UV,A3UV,A4UV,A5UV,A6UV,A7UV,A8UV
      common/ CDV/ A1DV,A2DV,A3DV,A4DV,A5DV,A6DV,A7DV,A8DV
      common/ CUS/ A1US,A2US,A3US,A4US,A5US,A6US,A7US,A8US
      common/ CDS/ A1DS,A2DS,A3DS,A4DS,A5DS,A6DS,A7DS,A8DS
      common/ CSS/ A1SS,A2SS,A3SS,A4SS,A5SS,A6SS,A7SS,A8SS
      common/ CGL/ A1GL,A2GL,A3GL,A4GL,A5GL,A6GL,A7GL,A8GL
      common/ CCH/ A1CH,A2CH,A3CH,A4CH,A5CH,A6CH,A7CH,A8CH
      common/ CBO/ A1BO,A2BO,A3BO,A4BO,A5BO,A6BO,A7BO,A8BO
      common/exp/aa
!      AA=2.5d0
!      AA=3d0 !2.5d0
      iinip=0

        OPEN(UNIT=10,FILE='FIT.GRID',STATUS='unknown')  
      write(*,*) "( ...writing fitted PDF grid"

       do i=1,nx
        x=xb(i)

         call distributions(X,xUV,xDV,xUb,xDb,xStr,xGL,xC,xbo)

        write(10,90)xuv,xdv,
     .             xub,xdb,
     .    xstr,xc,xbo,
     .    xgl

       enddo

      close(10)

       do i=1,nx-1
        x=xb(i)
         call distributions(X,UV,DV,US,DS,SS,GL,CH,BO)
         call result(X,RUV,RDV,RUB,RDB,RS,RC,RB,RG)
!         write(6,*)x,uv,uv/ruv,gl/rg
       enddo


  90   FORMAT (8(1PE15.7))

!      close(10)

      return
      end   

      subroutine result(X,RUV,RDV,RUB,RDB,RS,RC,RB,RG)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER (NPART=8, NX=52, NARG=1)
      DIMENSION XUVF(NX), XDVF(NX), XUBF(NX),
     1  XDBF(NX), XSF(NX), XCF(NX), XBF(NX), XGF(NX),
     2   XB(NX), ARRF(NX), NA(NARG), XT(NARG), PARTON(NPART,nx)
      SAVE XUVF, XDVF, XUBF, XDBF, XSF, XCF, XBF, XGF, NA, ARRF
      COMMON / INTINIP / IINIP

        DATA XB / 1.0E-6,5.E-6,
     1           1.0E-5, 1.4E-5, 2.0E-5, 3.0E-5, 4.5E-5, 6.7E-5,
     2           1.0E-4, 1.4E-4, 2.0E-4, 3.0E-4, 4.5E-4, 6.7E-4,
     3           1.0E-3, 1.4E-3, 2.0E-3, 3.0E-3, 4.5E-3, 6.7E-3,
     4           1.0E-2, 1.4E-2, 2.0E-2, 3.0E-2, 4.5E-2, 0.06, 0.08,
     5           0.1, 0.125, 0.15, 0.175, 0.2, 0.225, 0.25, 0.275,
     6           0.3, 0.325, 0.35, 0.375, 0.4,  0.45, 0.5, 0.55,
     7           0.6, 0.65,  0.7,  0.75,  0.8,  0.85, 0.9, 0.95, 1. /


      IF (IINIP .NE. 0) GOTO 16
        OPEN(UNIT=1,FILE='FIT.GRID',STATUS='unknown')
      IINIP = 1

      write(*,*) "( read grid"

       do i=1,NX
         ARRF(I) = DLOG(XB(I))     
       enddo
       NA(1)=NX
       do i=1,nx
        read(1,90) parton(1,i),parton(2,i),parton(3,i),parton(4,i),
     .             parton(5,i), parton(6,i),parton(7,i),parton(8,i)
        enddo
       do IX=1,NX-1
        XX=XB(IX)
        XB0V = XX**0.5 
        XB0S = XX**(-0.2) 
        XB1 = 1.-XX
        XUVF(IX) = PARTON(1,IX) / (XB1**3 * XB0V)
        XDVF(IX) = PARTON(2,IX) / (XB1**4 * XB0V)
        XUBF(IX) = PARTON(3,IX) / (XB1**7 * XB0S)
        XDBF(IX) = PARTON(4,IX) / (XB1**7 * XB0S)
        XSF(IX) = PARTON(5,IX) / (XB1**7 * XB0S)
        XCF(IX) = PARTON(6,IX) / (XB1**7 * XB0S)
        XBF(IX) = PARTON(7,IX) / (XB1**7 * XB0S)
        XGF(IX) = PARTON(8,IX) / (XB1**5 * XB0S)
        enddo
        XUVF(NX) = 0D0 
        XDVF(NX) = 0D0  
        XUBF(NX) = 0D0  
        XDBF(NX) =  0D0 
        XSF(NX) =  0D0 
        XCF(NX) =  0D0 
        XBF(NX) =  0D0 
        XGF(NX) =  0D0 


 90   FORMAT (8(1PE15.7))
 16   continue

*...INTERPOLATION :

        xt(1)=dlog(x)
        XB0V = X**0.5 
        XB0S = X**(-0.2) 
        XB1 = 1.-X

       RUV = FINT(NARG,XT,NA,ARRF,XUVF)*(XB1**3 * XB0V)
       RDV = FINT(NARG,XT,NA,ARRF,XDVF)*(XB1**4 * XB0V)
       RUB = FINT(NARG,XT,NA,ARRF,XUBF)* (XB1**7 * XB0S)
       RDB = FINT(NARG,XT,NA,ARRF,XDBF)* (XB1**7 * XB0S)
       RS = FINT(NARG,XT,NA,ARRF,XSF)  *(XB1**7 * XB0S)
       RC = FINT(NARG,XT,NA,ARRF,XCF)  *(XB1**7 * XB0S)
       RB = FINT(NARG,XT,NA,ARRF,XBF)  *(XB1**7 * XB0S)
       RG = FINT(NARG,XT,NA,ARRF,XGF)  *(XB1**5 * XB0S)     
       return

       end
  
      FUNCTION FINT(NARG,ARG,NENT,ENT,TABLE)
*********************************************************************
*                                                                   *
*   THE INTERPOLATION ROUTINE (CERN LIBRARY ROUTINE E104)           *
*                                                                   *
*********************************************************************
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
      PARAMETER (NX=52)
      DIMENSION ARG(5),NENT(5),ENT(nx),TABLE(nx)
      DIMENSION D(5),NCOMB(5),IENT(5)
      KD=1
      M=1
      JA=1
         DO 5 I=1,NARG
      NCOMB(I)=1
      JB=JA-1+NENT(I)
         DO 2 J=JA,JB
      IF (ARG(I).LE.ENT(J)) GO TO 3
    2 CONTINUE
      J=JB
    3 IF (J.NE.JA) GO TO 4
      J=J+1
    4 JR=J-1
      D(I)=(ENT(J)-ARG(I))/(ENT(J)-ENT(JR))
      IENT(I)=J-JA
      KD=KD+IENT(I)*M
      M=M*NENT(I)
    5 JA=JB+1
      FINT=0.
   10 FAC=1.
      IADR=KD
      IFADR=1
         DO 15 I=1,NARG
      IF (NCOMB(I).EQ.0) GO TO 12
      FAC=FAC*(1.-D(I))
      GO TO 15
   12 FAC=FAC*D(I)
      IADR=IADR-IFADR
   15 IFADR=IFADR*NENT(I)
      FINT=FINT+FAC*TABLE(IADR)
      IL=NARG
   40 IF (NCOMB(IL).EQ.0) GO TO 80
      NCOMB(IL)=0
      IF (IL.EQ.NARG) GO TO 10
      IL=IL+1
         DO 50  K=IL,NARG
   50 NCOMB(K)=1
      GO TO 10
   80 IL=IL-1
      IF(IL.NE.0) GO TO 40
      RETURN
      END

c computes pdfs in the approximated result at muf
      SUBROUTINE DISTRIBUTIONS(X,UV,DV,US,DS,SS,GL,CH,BO)
      implicit NONE
      double precision A1UV,A2UV,A3UV,A4UV,A5UV,A6UV,A7UV,A8UV
      double precision A1DV,A2DV,A3DV,A4DV,A5DV,A6DV,A7DV,A8DV
      double precision A1US,A2US,A3US,A4US,A5US,A6US,A7US,A8US 
      double precision A1DS,A2DS,A3DS,A4DS,A5DS,A6DS,A7DS,A8DS
      double precision A1SS,A2SS,A3SS,A4SS,A5SS,A6SS,A7SS,A8SS
      double precision A1GL,A2GL,A3GL,A4GL,A5GL,A6GL,A7GL,A8GL
      double precision A1CH,A2CH,A3CH,A4CH,A5CH,A6CH,A7CH,A8CH
      double precision A1BO,A2BO,A3BO,A4BO,A5BO,A6BO,A7BO,A8BO
      double precision aa,UV,DV,US,DS,SS,GL,CH,BO,U,D,X 
      common/ CUV/ A1UV,A2UV,A3UV,A4UV,A5UV,A6UV,A7UV,A8UV
      common/ CDV/ A1DV,A2DV,A3DV,A4DV,A5DV,A6DV,A7DV,A8DV
      common/ CUS/ A1US,A2US,A3US,A4US,A5US,A6US,A7US,A8US
      common/ CDS/ A1DS,A2DS,A3DS,A4DS,A5DS,A6DS,A7DS,A8DS
      common/ CSS/ A1SS,A2SS,A3SS,A4SS,A5SS,A6SS,A7SS,A8SS
      common/ CGL/ A1GL,A2GL,A3GL,A4GL,A5GL,A6GL,A7GL,A8GL
      common/ CCH/ A1CH,A2CH,A3CH,A4CH,A5CH,A6CH,A7CH,A8CH
      common/ CBO/ A1BO,A2BO,A3BO,A4BO,A5BO,A6BO,A7BO,A8BO
      common/exp/aa
       
       UV =A1UV*x**A2UV*(1-x)**A3UV*(1+A4UV*x+A5UV*x**(0.5)
     .     +A6UV*x**(1.5)+A7UV*X**2 + A8UV*X**(aa))
       DV =A1DV*x**A2DV*(1-x)**A3DV*(1+A4DV*x+A5DV*x**(0.5)
     .     +A6DV*x**(1.5)+A7DV*X**2 + A8DV*X**(aa))

       US =A1US*x**A2US*(1-x)**A3US*(1+A4US*x+A5US*x**(0.5)
     .     +A6US*x**(1.5)+A7US*X**2 + A8US*X**(aa))
       DS =A1DS*x**A2DS*(1-x)**A3DS*(1+A4DS*x+A5DS*x**(0.5)
     .     +A6DS*x**(1.5)+A7DS*X**2 + A8DS*X**(aa))

       U=UV+US
       D=DV+DS

       SS =A1SS*x**A2SS*(1-x)**A3SS*(1+A4SS*x+A5SS*x**(0.5)
     .     +A6SS*x**(1.5)+A7SS*X**2 + A8SS*X**(aa))

       GL =A1GL*x**A2GL*(1-x)**A3GL*(1+A4GL*x+A5GL*x**(0.5)
     .     +A6GL*x**(1.5)+A7GL*X**2 + A8GL*X**(aa))

       CH =A1CH*x**A2CH*(1-x)**A3CH*(1+A4CH*x+A5CH*x**(0.5)
     .     +A6CH*x**(1.5)+A7CH*X**2 + A8CH*X**(aa))

       BO =A1BO*x**A2BO*(1-x)**A3BO*(1+A4BO*x+A5BO*x**(0.5)
     .     +A6BO*x**(1.5)+A7BO*X**2 + A8BO*X**(aa))

       RETURN
       END
